/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package geopixelcountjava5;

import java.awt.print.*;
import java.awt.*;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.awt.image.RenderedImage;

/**
 *
 * @author Kenrick
 */
public class PrintImage implements Printable {

  private Image image;  // Image to print
  
  public PrintImage()
  {
      super();
  }
  
  public PrintImage(Image image)
  {
      super();
      this.image = image;
  }
  public int print(Graphics g, PageFormat pf, int page)
     throws PrinterException {

    // We have only one page, and 'page' is zero-based
    if (page > 0) {
         return NO_SUCH_PAGE;
    }

    // User (0,0) is typically outside the imageable
    // area, so we must translate by the X and Y values
    // in the PageFormat to avoid clipping.
    Graphics2D g2d = (Graphics2D)g;
    g2d.translate(pf.getImageableX(),
                  pf.getImageableY());

    // Now we perform our rendering
    // Have to scale the image so it fits on the page
     AffineTransform at = new AffineTransform();
     at.translate(0,0);

     //We need to scale the image properly so that it fits on one page.     
     double xScale = pf.getImageableWidth() / image.getWidth(null);
     double yScale = pf.getImageableHeight() / image.getHeight(null);
     // Maintain the aspect ratio by taking the min of those 2 factors and using it to scale both dimensions.
     double aspectScale = Math.min(xScale, yScale);
     at.setToScale(aspectScale, aspectScale);

     BufferedImage imageTemp = new BufferedImage(image.getWidth(null), image.getHeight(null), BufferedImage.TYPE_INT_RGB);    
     Graphics2D gNew = imageTemp.createGraphics();
     gNew.drawImage(image, 0, 0, null);
     g2d.drawRenderedImage(imageTemp, at);
    
    // tell the caller that this page is part of the
    // printed document
    return PAGE_EXISTS;
  }
}